if (!defined &_INET_IP_H) {
    eval 'sub _INET_IP_H {1;}';
    if (defined &__cplusplus) {
    }
    require 'sys/isa_defs.ph';
    eval 'sub IP_DEBUG {1;}';
    eval 'sub IP_CSUM {
        local($mp, $off, $sum) = @_;
        eval "(~ &ip_cksum($mp, $off, $sum) & 0xFFFF)";
    }';
    eval 'sub IP_CSUM_PARTIAL {
        local($mp, $off, $sum) = @_;
        eval " &ip_cksum($mp, $off, $sum)";
    }';
    eval 'sub ILL_FRAG_HASH_TBL_COUNT {(64);}';
    eval 'sub ILL_FRAG_HASH_TBL_SIZE {( &ILL_FRAG_HASH_TBL_COUNT * $sizeof{ &ipfb_t});}';
    eval 'sub IP_DEV_NAME {"/dev/ip";}';
    eval 'sub IP_MOD_NAME {"ip";}';
    eval 'sub IP_ADDR_LEN {4;}';
    eval 'sub IP_ARP_PROTO_TYPE {0x0800;}';
    eval 'sub IP_VERSION {4;}';
    eval 'sub IP_SIMPLE_HDR_LENGTH_IN_WORDS {5;}';
    eval 'sub IP_SIMPLE_HDR_LENGTH {20;}';
    eval 'sub IP_MAX_HDR_LENGTH {64;}';
    eval 'sub IP_SIMPLE_HDR_VERSION {(( &IP_VERSION << 4) |  &IP_SIMPLE_HDR_LENGTH_IN_WORDS);}';
    eval 'sub IP_IOCTL {((ord(\'i\'<<8)|\'p\'));}';
    eval 'sub IP_IOC_IRE_DELETE {4;}';
    eval 'sub IP_IOC_IRE_DELETE_NO_REPLY {5;}';
    eval 'sub IP_IOC_IRE_ADVISE_NO_REPLY {6;}';
    eval 'sub IPOPT_EOL {0x00;}';
    eval 'sub IPOPT_NOP {0x01;}';
    eval 'sub IPOPT_SEC {0x82;}';
    eval 'sub IPOPT_LSRR {0x83;}';
    eval 'sub IPOPT_IT {0x44;}';
    eval 'sub IPOPT_RR {0x07;}';
    eval 'sub IPOPT_SID {0x88;}';
    eval 'sub IPOPT_SSRR {0x89;}';
    eval 'sub IPOPT_COPY {0x80;}';
    eval 'sub IPOPT_POS_VAL {0;}';
    eval 'sub IPOPT_POS_LEN {1;}';
    eval 'sub IPOPT_POS_OFF {2;}';
    eval 'sub IPOPT_POS_OV_FLG {3;}';
    eval 'sub IPOPT_MINOFF_SR {4;}';
    eval 'sub IPOPT_MINOFF_IT {5;}';
    eval 'sub IPOPT_MINLEN_IT {5;}';
    eval 'sub IPOPT_IT_TIME {0;}';
    eval 'sub IPOPT_IT_TIME_ADDR {1;}';
    eval 'sub IPOPT_IT_SPEC {3;}';
    eval 'sub IPOPT_IT_SPEC_BSD {2;}';
    eval 'sub IPOPT_IT_TIMELEN {4;}';
    eval 'sub IP_FORWARD_NEVER {0;}';
    eval 'sub IP_FORWARD_ALWAYS {1;}';
    eval 'sub IP_FORWARD_AUTOMATIC {2;}';
    eval 'sub WE_ARE_FORWARDING {( &ip_g_forward ==  &IP_FORWARD_ALWAYS || ( &ip_g_forward ==  &IP_FORWARD_AUTOMATIC &&  &ipif_g_count > 1));}';
    eval 'sub IPH_HDR_LENGTH {
        local($ipha) = @_;
        eval "(((( &iph_t *)$ipha)-> &iph_version_and_hdr_length & 0xF) << 2)";
    }';
    eval 'sub IP_REASS_START {
        local($mp) = @_;
        eval "((($mp)-> &b_next))";
    }';
    eval 'sub IP_REASS_SET_START {
        local($mp, $u) = @_;
        eval "(($mp)-> &b_next = ( &mblk_t *)($u))";
    }';
    eval 'sub IP_REASS_END {
        local($mp) = @_;
        eval "((($mp)-> &b_prev))";
    }';
    eval 'sub IP_REASS_SET_END {
        local($mp, $u) = @_;
        eval "(($mp)-> &b_prev = ( &mblk_t *)($u))";
    }';
    eval 'sub ATOMIC_32_INC {
        local($u1, $p) = @_;
        eval "($u1 = ++(*($p)))";
    }';
    eval 'sub ATOMIC_32_INIT {
        local($au32p) = @_;
        eval "";
    }';
    eval 'sub ATOMIC_32_ASSIGN {
        local($au32p, $val) = @_;
        eval "(($au32p)[0] = ($val))";
    }';
    eval 'sub ATOMIC_32_VAL {
        local($au32p) = @_;
        eval "(($au32p)[0])";
    }';
    if (!defined &A_U32) {
	eval 'sub A_U32 {unsigned long;}';
    }
    eval 'sub IRE_HASH_TBL_COUNT {256;}';
    eval 'sub INE_HASH_TBL_COUNT {32;}';
    eval 'sub HASH_BIT_COUNT {8;}';
    if (defined &_BIG_ENDIAN) {
	eval 'sub IRE_ADDR_HASH {
	    local($l1) = @_;
	    eval "(( &u32)(($l1 >>  &HASH_BIT_COUNT) ^ ($l1)) & ~(~0 <<  &HASH_BIT_COUNT))";
	}';
    }
    else {
	eval 'sub IRE_ADDR_HASH {
	    local($l1) = @_;
	    eval "(( &u32)(($l1 <<  &HASH_BIT_COUNT) ^ ($l1)) >> ( &u32)(32 -  &HASH_BIT_COUNT))";
	}';
    }
    eval 'sub INE_ADDR_HASH {
        local($l1) = @_;
        eval "(((($l1 >> 16) ^ ($l1)) ^ ((($l1 >> 16) ^ ($l1)) >> 8)) %  &INE_HASH_TBL_COUNT)";
    }';
    if (!defined &IRE_DB_TYPE) {
	eval 'sub IRE_DB_TYPE { &M_SIG;}';
    }
    if (!defined &IRE_DB_REQ_TYPE) {
	eval 'sub IRE_DB_REQ_TYPE { &M_PCSIG;}';
    }
    eval 'sub IRE_IS_TARGET {
        local($ire) = @_;
        eval "(($ire)&& (($ire)-> &ire_type !=  &IRE_BROADCAST))";
    }';
    eval 'sub IREP_LOOKUP {
        local($addr) = @_;
        eval "& &ire_hash_tbl[ &IRE_ADDR_HASH($addr)]";
    }';
    eval 'sub IREP_ASSOC_LOOKUP {
        local($addr) = @_;
        eval "& &ire_assoc_hash_tbl[ &IRE_ADDR_HASH($addr)]";
    }';
    eval 'sub ICMP_ECHO_REPLY {0;}';
    eval 'sub ICMP_DEST_UNREACHABLE {3;}';
    eval 'sub ICMP_SOURCE_QUENCH {4;}';
    eval 'sub ICMP_REDIRECT {5;}';
    eval 'sub ICMP_ECHO_REQUEST {8;}';
    eval 'sub ICMP_ROUTER_ADVERTISEMENT {9;}';
    eval 'sub ICMP_ROUTER_SOLICITATION {10;}';
    eval 'sub ICMP_TIME_EXCEEDED {11;}';
    eval 'sub ICMP_PARAM_PROBLEM {12;}';
    eval 'sub ICMP_TIME_STAMP_REQUEST {13;}';
    eval 'sub ICMP_TIME_STAMP_REPLY {14;}';
    eval 'sub ICMP_INFO_REQUEST {15;}';
    eval 'sub ICMP_INFO_REPLY {16;}';
    eval 'sub ICMP_ADDRESS_MASK_REQUEST {17;}';
    eval 'sub ICMP_ADDRESS_MASK_REPLY {18;}';
    eval 'sub ICMP_TTL_EXCEEDED {0;}';
    eval 'sub ICMP_REASSEMBLY_TIME_EXCEEDED {1;}';
    eval 'sub ICMP_NET_UNREACHABLE {0;}';
    eval 'sub ICMP_HOST_UNREACHABLE {1;}';
    eval 'sub ICMP_PROTOCOL_UNREACHABLE {2;}';
    eval 'sub ICMP_PORT_UNREACHABLE {3;}';
    eval 'sub ICMP_FRAGMENTATION_NEEDED {4;}';
    eval 'sub ICMP_SOURCE_ROUTE_FAILED {5;}';
    eval 'sub icmph_echo_ident { &icmph_u. &u_echo. &u_echo_ident;}';
    eval 'sub icmph_echo_seqnum { &icmph_u. &u_echo. &u_echo_seqnum;}';
    eval 'sub icmph_du_zero { &icmph_u. &u_du. &u_du_zero;}';
    eval 'sub icmph_du_mtu { &icmph_u. &u_du. &u_du_mtu;}';
    eval 'sub icmph_pp_ptr { &icmph_u. &u_pp. &u_pp_ptr;}';
    eval 'sub icmph_rd_gateway { &icmph_u. &u_rd. &u_rd_gateway;}';
    eval 'sub ICMPH_SIZE {8;}';
    eval 'sub IPH_DF {0x4000;}';
    eval 'sub IPH_MF {0x2000;}';
    eval 'sub IPH_OFFSET {0x1FFF;}';
    if (defined &_KERNEL) {
    }
    eval 'sub IRE_BROADCAST {0x0001;}';
    eval 'sub IRE_GATEWAY {0x0002;}';
    eval 'sub IRE_LOCAL {0x0004;}';
    eval 'sub IRE_LOOPBACK {0x0008;}';
    eval 'sub IRE_NET {0x0010;}';
    eval 'sub IRE_ROUTE {0x0020;}';
    eval 'sub IRE_SUBNET {0x0040;}';
    eval 'sub IRE_RESOLVER {0x0080;}';
    eval 'sub IRE_ROUTE_ASSOC {0x0100;}';
    eval 'sub IRE_ROUTE_REDIRECT {0x0200;}';
    eval 'sub IRE_INTERFACE {( &IRE_SUBNET| &IRE_RESOLVER);}';
    if (defined &_KERNEL) {
	eval 'sub ipc_udp_port { &ipc_ipcu. &ipcu_udp. &ipcu_udp_port;}';
	eval 'sub ipc_udp_addr { &ipc_ipcu. &ipcu_udp. &ipcu_udp_addr;}';
	eval 'sub ipc_tcp_laddr { &ipc_ipcu. &ipcu_tcp. &ipcu_tcp_laddr;}';
	eval 'sub ipc_tcp_faddr { &ipc_ipcu. &ipcu_tcp. &ipcu_tcp_faddr;}';
	eval 'sub ipc_tcp_ports { &ipc_ipcu. &ipcu_tcp. &ipcu_tcp_ports;}';
	eval 'sub ipif_wq { &ipif_ill-> &ill_wq;}';
	eval 'sub ipif_rq { &ipif_ill-> &ill_rq;}';
	eval 'sub ipif_subnet_type { &ipif_ill-> &ill_subnet_type;}';
	eval 'sub ipif_resolver_mp { &ipif_ill-> &ill_resolver_mp;}';
	eval 'sub ipif_ipif_up_count { &ipif_ill-> &ill_ipif_up_count;}';
	eval 'sub ipif_ipif_pending { &ipif_ill-> &ill_ipif_pending;}';
	eval 'sub ipif_bcast_mp { &ipif_ill-> &ill_bcast_mp;}';
	eval 'sub ill_first_mp_to_free { &ill_hdr_mp;}';
	eval 'sub ill_last_mp_to_free { &ill_detach_mp;}';
    }
    eval 'sub ipic_cmd { &ipic_ipllc. &ipllc_cmd;}';
    eval 'sub ipic_ll_name_length { &ipic_ipllc. &ipllc_name_length;}';
    eval 'sub ipic_ll_name_offset { &ipic_ipllc. &ipllc_name_offset;}';
    eval 'sub ipid_cmd { &ipid_ipllc. &ipllc_cmd;}';
    if (defined &_KERNEL) {
	eval 'sub ip_g_forward { &ip_param_arr[0]. &ip_param_value;}';
	eval 'sub ip_respond_to_address_mask_broadcast { &ip_param_arr[1]. &ip_param_value;}';
	eval 'sub ip_g_resp_to_address_mask { &ip_param_arr[1]. &ip_param_value;}';
	eval 'sub ip_debug { &ip_param_arr[7]. &ip_param_value;}';
	eval 'sub ip_mrtdebug { &ip_param_arr[8]. &ip_param_value;}';
	eval 'sub ip_timer_interval { &ip_param_arr[9]. &ip_param_value;}';
	eval 'sub ip_ire_flush_interval { &ip_param_arr[10]. &ip_param_value;}';
	eval 'sub ip_path_mtu_discovery { &ip_param_arr[18]. &ip_param_value;}';
	eval 'sub ip_ignore_delete_time { &ip_param_arr[19]. &ip_param_value;}';
	eval 'sub ip_broadcast_ttl { &ip_param_arr[22]. &ip_param_value;}';
	if (defined &_BIG_ENDIAN) {
	    eval 'sub N_IN_CLASSD_NET { &IN_CLASSD_NET;}';
	    eval 'sub N_INADDR_UNSPEC_GROUP { &INADDR_UNSPEC_GROUP;}';
	}
	else {
	    eval 'sub N_IN_CLASSD_NET {0x000000f0;}';
	    eval 'sub N_INADDR_UNSPEC_GROUP {0x000000e0;}';
	}
	eval 'sub CLASSD {
	    local($addr) = @_;
	    eval "((($addr) &  &N_IN_CLASSD_NET) ==  &N_INADDR_UNSPEC_GROUP)";
	}';
	if (defined &IP_DEBUG) {
	    eval 'sub ip0dbg {
	        local($a) = @_;
	        eval " &printf $a";
	    }';
	    eval 'sub ip1dbg {
	        local($a) = @_;
	        eval " &if ( &ip_debug)  &printf $a";
	    }';
	    eval 'sub ip2dbg {
	        local($a) = @_;
	        eval " &if ( &ip_debug > 1)  &printf $a";
	    }';
	    eval 'sub ip3dbg {
	        local($a) = @_;
	        eval " &if ( &ip_debug > 2)  &printf $a";
	    }';
	}
	else {
	    eval 'sub ip0dbg {
	        local($a) = @_;
	        eval "";
	    }';
	    eval 'sub ip1dbg {
	        local($a) = @_;
	        eval "";
	    }';
	    eval 'sub ip2dbg {
	        local($a) = @_;
	        eval "";
	    }';
	    eval 'sub ip3dbg {
	        local($a) = @_;
	        eval "";
	    }';
	}
	if (defined &__STDC__) {
	}
	else {
	}
    }
    if (defined &__cplusplus) {
    }
}
1;
