if (!defined &_NFS_EXPORT_H) {
    eval 'sub _NFS_EXPORT_H {1;}';
    if (defined &__cplusplus) {
    }
    eval 'sub EX_RDONLY {0x01;}';
    eval 'sub EX_RDMOSTLY {0x02;}';
    eval 'sub EX_RDWR {0x04;}';
    eval 'sub EX_EXCEPTIONS {0x08;}';
    eval 'sub EX_NOSUID {0x10;}';
    eval 'sub EX_ACLOK {0x20;}';
    eval 'sub EX_ALL {( &EX_RDONLY |  &EX_RDMOSTLY |  &EX_RDWR |  &EX_EXCEPTIONS |  &EX_NOSUID |  &EX_ACLOK);}';
    eval 'sub EXMAXADDRS {256;}';
    eval 'sub EXMAXROOTADDRS {256;}';
    eval 'sub EXMAXROOTNAMES {256;}';
    eval 'sub ex_des { &ex_u. &exdes;}';
    eval 'sub ex_unix { &ex_u. &exunix;}';
    eval 'sub ex_kerb { &ex_u. &exkerb;}';
    if (defined &_KERNEL) {
	eval 'sub EQFSID {
	    local($fsidp1, $fsidp2) = @_;
	    eval "((($fsidp1)-> &val[0] == ($fsidp2)-> &val[0]) && (($fsidp1)-> &val[1] == ($fsidp2)-> &val[1]))";
	}';
	eval 'sub EQFID {
	    local($fidp1, $fidp2) = @_;
	    eval "(($fidp1)-> &fid_len == ($fidp2)-> &fid_len &&  &nfs_fhbcmp(($fidp1)-> &fid_data, ($fidp2)-> &fid_data, ( &uint_t)($fidp1)-> &fid_len) == 0)";
	}';
	eval 'sub rdonly {
	    local($exi, $req) = @_;
	    eval "(((($exi)-> &exi_export. &ex_flags &  &EX_RDONLY) && ((!(($exi)-> &exi_export. &ex_flags &  &EX_EXCEPTIONS)) || ! &hostinlist( &svc_getrpccaller(($req)-> &rq_xprt), &($exi)-> &exi_export. &ex_rwaddrs))) || ((($exi)-> &exi_export. &ex_flags &  &EX_RDWR) && ((($exi)-> &exi_export. &ex_flags &  &EX_EXCEPTIONS) &&  &hostinlist( &svc_getrpccaller(($req)-> &rq_xprt), &($exi)-> &exi_export. &ex_roaddrs))))";
	}';
    }
    if (defined &__cplusplus) {
    }
}
1;
