if (!defined &_NSS_DBDEFS_H) {
    eval 'sub _NSS_DBDEFS_H {1;}';
    require 'errno.ph';
    require 'netdb.ph';
    require 'limits.ph';
    require 'nss_common.ph';
    if (defined &__cplusplus) {
    }
    if (!defined &NSS_INCLUDE_UNSAFE) {
	eval 'sub NSS_INCLUDE_UNSAFE {1;}';
    }
    eval 'sub NSS_DBNAM_ALIASES {"aliases";}';
    eval 'sub NSS_DBNAM_AUTOMOUNT {"automount";}';
    eval 'sub NSS_DBNAM_BOOTPARAMS {"bootparams";}';
    eval 'sub NSS_DBNAM_ETHERS {"ethers";}';
    eval 'sub NSS_DBNAM_GROUP {"group";}';
    eval 'sub NSS_DBNAM_HOSTS {"hosts";}';
    eval 'sub NSS_DBNAM_NETGROUP {"netgroup";}';
    eval 'sub NSS_DBNAM_NETMASKS {"netmasks";}';
    eval 'sub NSS_DBNAM_NETWORKS {"networks";}';
    eval 'sub NSS_DBNAM_PASSWD {"passwd";}';
    eval 'sub NSS_DBNAM_PROTOCOLS {"protocols";}';
    eval 'sub NSS_DBNAM_PUBLICKEY {"publickey";}';
    eval 'sub NSS_DBNAM_RPC {"rpc";}';
    eval 'sub NSS_DBNAM_SERVICES {"services";}';
    eval 'sub NSS_DBNAM_SHADOW {"shadow";}';
    eval 'sub NSS_DBNAM_PASSWD_COMPAT {"passwd_compat";}';
    eval 'sub NSS_DBNAM_GROUP_COMPAT {"group_compat";}';
    eval 'sub NSS_FILES_NS {"files nis";}';
    eval 'sub NSS_NS_FALLBACK {"nis [NOTFOUND=return] files";}';
    eval 'sub NSS_NS_ONLY {"nis";}';
    eval 'sub NSS_DEFCONF_ALIASES { &NSS_FILES_NS;}';
    eval 'sub NSS_DEFCONF_AUTOMOUNT { &NSS_FILES_NS;}';
    eval 'sub NSS_DEFCONF_BOOTPARAMS { &NSS_NS_FALLBACK;}';
    eval 'sub NSS_DEFCONF_ETHERS { &NSS_NS_FALLBACK;}';
    eval 'sub NSS_DEFCONF_GROUP { &NSS_FILES_NS;}';
    eval 'sub NSS_DEFCONF_HOSTS { &NSS_NS_FALLBACK;}';
    eval 'sub NSS_DEFCONF_NETGROUP { &NSS_NS_ONLY;}';
    eval 'sub NSS_DEFCONF_NETMASKS { &NSS_NS_FALLBACK;}';
    eval 'sub NSS_DEFCONF_NETWORKS { &NSS_NS_FALLBACK;}';
    eval 'sub NSS_DEFCONF_PASSWD { &NSS_FILES_NS;}';
    eval 'sub NSS_DEFCONF_PROTOCOLS { &NSS_NS_FALLBACK;}';
    eval 'sub NSS_DEFCONF_PUBLICKEY { &NSS_NS_FALLBACK;}';
    eval 'sub NSS_DEFCONF_RPC { &NSS_NS_FALLBACK;}';
    eval 'sub NSS_DEFCONF_SERVICES { &NSS_FILES_NS;}';
    eval 'sub NSS_DEFCONF_GROUP_COMPAT { &NSS_NS_ONLY;}';
    eval 'sub NSS_DEFCONF_PASSWD_COMPAT { &NSS_NS_ONLY;}';
    eval 'sub NSS_BUFSIZ {1024;}';
    eval 'sub NSS_LINELEN_GROUP {(( &NSS_BUFSIZ) * 4);}';
    eval 'sub NSS_LINELEN_HOSTS { &NSS_BUFSIZ;}';
    eval 'sub NSS_LINELEN_NETMASKS { &NSS_BUFSIZ;}';
    eval 'sub NSS_LINELEN_NETWORKS { &NSS_BUFSIZ;}';
    eval 'sub NSS_LINELEN_PASSWD { &NSS_BUFSIZ;}';
    eval 'sub NSS_LINELEN_PROTOCOLS { &NSS_BUFSIZ;}';
    eval 'sub NSS_LINELEN_RPC { &NSS_BUFSIZ;}';
    eval 'sub NSS_LINELEN_SERVICES { &NSS_BUFSIZ;}';
    eval 'sub NSS_LINELEN_SHADOW { &NSS_BUFSIZ;}';
    eval 'sub NSS_LINELEN_ETHERS { &NSS_BUFSIZ;}';
    eval 'sub NSS_LINELEN_BOOTPARAMS { &NSS_BUFSIZ;}';
    eval 'sub NSS_BUFLEN_GROUP {( &NSS_LINELEN_GROUP + 800 * $sizeof{\'char\' *});}';
    eval 'sub NSS_BUFLEN_HOSTS {( &NSS_LINELEN_HOSTS + ( &MAXALIASES +  &MAXADDRS + 2) * $sizeof{\'char\' *});}';
    eval 'sub NSS_BUFLEN_NETGROUP {( &MAXHOSTNAMELEN * 2 +  &LOGNAME_MAX + 3);}';
    eval 'sub NSS_BUFLEN_NETWORKS { &NSS_LINELEN_NETWORKS;}';
    eval 'sub NSS_BUFLEN_PASSWD { &NSS_LINELEN_PASSWD;}';
    eval 'sub NSS_BUFLEN_PROTOCOLS { &NSS_LINELEN_PROTOCOLS;}';
    eval 'sub NSS_BUFLEN_RPC { &NSS_LINELEN_RPC;}';
    eval 'sub NSS_BUFLEN_SERVICES { &NSS_LINELEN_SERVICES;}';
    eval 'sub NSS_BUFLEN_SHADOW { &NSS_LINELEN_SHADOW;}';
    eval 'sub NSS_BUFLEN_ETHERS { &NSS_LINELEN_ETHERS;}';
    eval 'sub NSS_BUFLEN_BOOTPARAMS { &NSS_LINELEN_BOOTPARAMS;}';
    if (defined( &__STDC__)) {
    }
    else {
    }
    if (defined( &__STDC__)) {
    }
    else {
    }
    eval 'sub NSS_XbyY_ALLOC {
        local($bufpp, $str_size, $buf_size) = @_;
        eval "( (*$bufpp) == 0 ? (*$bufpp) =  &_nss_XbyY_buf_alloc($str_size, $buf_size) : (*$bufpp))";
    }';
    eval 'sub NSS_XbyY_FREE {
        local($bufpp) = @_;
        eval "( &_nss_XbyY_buf_free(*$bufpp), (*$bufpp) = 0)";
    }';
    if (defined( &__STDC__)) {
    }
    else {
    }
    eval 'sub NSS_STR_PARSE_SUCCESS {0;}';
    eval 'sub NSS_STR_PARSE_PARSE {1;}';
    eval 'sub NSS_STR_PARSE_ERANGE {2;}';
    eval 'sub NSS_XbyY_INIT {
        local($str, $res, $bufp, $len, $func) = @_;
        eval "( ($str)-> &buf. &result = ($res), ($str)-> &buf. &buffer = ($bufp), ($str)-> &buf. &buflen = ($len), ($str)-> &stayopen = 0, ($str)-> &str2ent = ($func), ($str)-> &returnval = 0, ($str)-> &erange = 0)";
    }';
    eval 'sub NSS_XbyY_FINI {
        local($str) = @_;
        eval "( ($str)-> &returnval == 0 && ($str)-> &erange && ( &errno =  &ERANGE), ($str)-> &returnval)";
    }';
    if (defined( &__STDC__)) {
    }
    else {
    }
    eval 'sub NSS_DBOP_GROUP_BYNAME {( &NSS_DBOP_next_iter);}';
    eval 'sub NSS_DBOP_GROUP_BYGID {( &NSS_DBOP_GROUP_BYNAME + 1);}';
    eval 'sub NSS_DBOP_GROUP_BYMEMBER {( &NSS_DBOP_GROUP_BYGID + 1);}';
    eval 'sub NSS_DBOP_PASSWD_BYNAME {( &NSS_DBOP_next_iter);}';
    eval 'sub NSS_DBOP_PASSWD_BYUID {( &NSS_DBOP_PASSWD_BYNAME + 1);}';
    eval 'sub NSS_DBOP_SHADOW_BYNAME {( &NSS_DBOP_PASSWD_BYNAME);}';
    eval 'sub NSS_DBOP_HOSTS_BYNAME {( &NSS_DBOP_next_iter);}';
    eval 'sub NSS_DBOP_HOSTS_BYADDR {( &NSS_DBOP_HOSTS_BYNAME + 1);}';
    eval 'sub NSS_DBOP_RPC_BYNAME {( &NSS_DBOP_next_iter);}';
    eval 'sub NSS_DBOP_RPC_BYNUMBER {( &NSS_DBOP_RPC_BYNAME + 1);}';
    eval 'sub NSS_DBOP_NETWORKS_BYNAME {( &NSS_DBOP_next_iter);}';
    eval 'sub NSS_DBOP_NETWORKS_BYADDR {( &NSS_DBOP_NETWORKS_BYNAME + 1);}';
    eval 'sub NSS_DBOP_SERVICES_BYNAME {( &NSS_DBOP_next_iter);}';
    eval 'sub NSS_DBOP_SERVICES_BYPORT {( &NSS_DBOP_SERVICES_BYNAME + 1);}';
    eval 'sub NSS_DBOP_PROTOCOLS_BYNAME {( &NSS_DBOP_next_iter);}';
    eval 'sub NSS_DBOP_PROTOCOLS_BYNUMBER {( &NSS_DBOP_PROTOCOLS_BYNAME + 1);}';
    eval 'sub NSS_DBOP_ETHERS_HOSTTON {( &NSS_DBOP_next_noiter);}';
    eval 'sub NSS_DBOP_ETHERS_NTOHOST {( &NSS_DBOP_ETHERS_HOSTTON + 1);}';
    eval 'sub NSS_DBOP_BOOTPARAMS_BYNAME {( &NSS_DBOP_next_noiter);}';
    eval 'sub NSS_DBOP_NETGROUP_IN {( &NSS_DBOP_next_iter);}';
    eval 'sub NSS_DBOP_NETGROUP_SET {( &NSS_DBOP_NETGROUP_IN + 1);}';
    eval 'sub ROUND_DOWN {
        local($n, $align) = @_;
        eval "(($n) & ~(($align) - 1))";
    }';
    eval 'sub ROUND_UP {
        local($n, $align) = @_;
        eval " &ROUND_DOWN(($n) + ($align) - 1, ($align))";
    }';
    if (defined &__cplusplus) {
    }
}
1;
