if (!defined &_NIS_H_RPCGEN) {
    eval 'sub _NIS_H_RPCGEN {1;}';
    require 'rpc/rpc.ph';
    if (defined &__cplusplus) {
    }
    require 'rpcsvc/nis_tags.ph';
    require 'rpc/xdr.ph';
    if (!defined &__nis_object_h) {
	eval 'sub __nis_object_h {1;}';
	eval 'sub NIS_MAXSTRINGLEN {255;}';
	eval 'sub NIS_MAXNAMELEN {1024;}';
	eval 'sub NIS_MAXATTRNAME {32;}';
	eval 'sub NIS_MAXATTRVAL {2048;}';
	eval 'sub NIS_MAXCOLUMNS {64;}';
	eval 'sub NIS_MAXATTR {16;}';
	eval 'sub NIS_MAXPATH {1024;}';
	eval 'sub NIS_MAXREPLICAS {128;}';
	eval 'sub NIS_MAXLINKS {16;}';
	eval 'sub NIS_PK_NONE {0;}';
	eval 'sub NIS_PK_DH {1;}';
	eval 'sub NIS_PK_RSA {2;}';
	eval 'sub NIS_PK_KERB {3;}';
	eval 'sub EN_BINARY {1;}';
	eval 'sub EN_CRYPT {2;}';
	eval 'sub EN_XDR {4;}';
	eval 'sub EN_MODIFIED {8;}';
	eval 'sub EN_ASN1 {64;}';
	eval 'sub TA_BINARY {1;}';
	eval 'sub TA_CRYPT {2;}';
	eval 'sub TA_XDR {4;}';
	eval 'sub TA_SEARCHABLE {8;}';
	eval 'sub TA_CASE {16;}';
	eval 'sub TA_MODIFIED {32;}';
	eval 'sub TA_ASN1 {64;}';
    }
    eval 'sub ZMH_VC {1;}';
    eval 'sub ZMH_DG {2;}';
    eval 'sub ZMH_AUTH {4;}';
    eval 'sub NIS_READ_ACC {1;}';
    eval 'sub NIS_MODIFY_ACC {2;}';
    eval 'sub NIS_CREATE_ACC {4;}';
    eval 'sub NIS_DESTROY_ACC {8;}';
    eval 'sub WORLD {
        local($a, $m) = @_;
        eval "((($a) & ($m)) != 0)";
    }';
    eval 'sub GROUP {
        local($a, $m) = @_;
        eval "((($a) & (($m) << 8)) != 0)";
    }';
    eval 'sub OWNER {
        local($a, $m) = @_;
        eval "((($a) & (($m) << 16)) != 0)";
    }';
    eval 'sub NOBODY {
        local($a, $m) = @_;
        eval "((($a) & (($m) << 24)) != 0)";
    }';
    eval 'sub OATYPE {
        local($d, $n) = @_;
        eval "((($d)-> &do_armask. &do_armask_val+$n)-> &oa_otype)";
    }';
    eval 'sub OARIGHTS {
        local($d, $n) = @_;
        eval "((($d)-> &do_armask. &do_armask_val+$n)-> &oa_rights)";
    }';
    eval 'sub WORLD_DEFAULT {( &NIS_READ_ACC);}';
    eval 'sub GROUP_DEFAULT {( &NIS_READ_ACC << 8);}';
    eval 'sub OWNER_DEFAULT {(( &NIS_READ_ACC +  &NIS_MODIFY_ACC +  &NIS_CREATE_ACC +  &NIS_DESTROY_ACC) << 16);}';
    eval 'sub DEFAULT_RIGHTS {( &WORLD_DEFAULT |  &GROUP_DEFAULT |  &OWNER_DEFAULT);}';
    eval 'sub NIS_RES_NUMOBJ {
        local($x) = @_;
        eval "(($x)-> &objects. &objects_len)";
    }';
    eval 'sub NIS_RES_OBJECT {
        local($x) = @_;
        eval "(($x)-> &objects. &objects_val)";
    }';
    eval 'sub NIS_RES_COOKIE {
        local($x) = @_;
        eval "(($x)-> &cookie)";
    }';
    eval 'sub NIS_RES_STATUS {
        local($x) = @_;
        eval "(($x)-> &status)";
    }';
    eval 'sub TA_data { &zo_data. &objdata_u. &ta_data;}';
    eval 'sub EN_data { &zo_data. &objdata_u. &en_data;}';
    eval 'sub DI_data { &zo_data. &objdata_u. &di_data;}';
    eval 'sub LI_data { &zo_data. &objdata_u. &li_data;}';
    eval 'sub GR_data { &zo_data. &objdata_u. &gr_data;}';
    eval 'sub __type_of {
        local($o) = @_;
        eval "(($o)-> &zo_data. &zo_type)";
    }';
    eval 'sub ENTRY_VAL {
        local($obj, $col) = @_;
        eval "($obj)-> &EN_data. &en_cols. &en_cols_val[$col]. &ec_value. &ec_value_val";
    }';
    eval 'sub ENTRY_LEN {
        local($obj, $col) = @_;
        eval "($obj)-> &EN_data. &en_cols. &en_cols_val[$col]. &ec_value. &ec_value_len";
    }';
    if (defined &__cplusplus) {
    }
    require 'rpcsvc/nislib.ph';
}
1;
