if (!defined &_SYS_ASY_H) {
    eval 'sub _SYS_ASY_H {1;}';
    if (defined &__cplusplus) {
    }
    require 'sys/tty.ph';
    require 'sys/ksynch.ph';
    require 'sys/dditypes.ph';
    if (defined &_VPIX) {
	require 'sys/v86intr.ph';
    }
    eval 'sub DAT {0;}';
    eval 'sub ICR {1;}';
    eval 'sub ISR {2;}';
    eval 'sub LCR {3;}';
    eval 'sub MCR {4;}';
    eval 'sub LSR {5;}';
    eval 'sub MSR {6;}';
    eval 'sub DLL {0;}';
    eval 'sub DLH {1;}';
    eval 'sub FIFOR { &ISR;}';
    eval 'sub INB {
        local($a, $off) = @_;
        eval "( &inb(($a)+($off)))";
    }';
    eval 'sub OUTB {
        local($a, $off, $val) = @_;
        eval "( &outb(($a)+($off), ($val)))";
    }';
    eval 'sub WLS0 {0x01;}';
    eval 'sub WLS1 {0x02;}';
    eval 'sub STB {0x04;}';
    eval 'sub PEN {0x08;}';
    eval 'sub EPS {0x10;}';
    eval 'sub SETBREAK {0x40;}';
    eval 'sub DLAB {0x80;}';
    eval 'sub RXLEN {0x03;}';
    eval 'sub STOP1 {0x00;}';
    eval 'sub STOP2 {0x04;}';
    eval 'sub PAREN {0x08;}';
    eval 'sub PAREVN {0x10;}';
    eval 'sub PARMARK {0x20;}';
    eval 'sub SNDBRK {0x40;}';
    eval 'sub BITS5 {0x00;}';
    eval 'sub BITS6 {0x01;}';
    eval 'sub BITS7 {0x02;}';
    eval 'sub BITS8 {0x03;}';
    eval 'sub ASY110 {1047;}';
    eval 'sub ASY150 {768;}';
    eval 'sub ASY300 {384;}';
    eval 'sub ASY600 {192;}';
    eval 'sub ASY1200 {96;}';
    eval 'sub ASY2400 {48;}';
    eval 'sub ASY4800 {24;}';
    eval 'sub ASY9600 {12;}';
    eval 'sub RCA {0x01;}';
    eval 'sub OVRRUN {0x02;}';
    eval 'sub PARERR {0x04;}';
    eval 'sub FRMERR {0x08;}';
    eval 'sub BRKDET {0x10;}';
    eval 'sub XHRE {0x20;}';
    eval 'sub XSRE {0x40;}';
    eval 'sub RFBE {0x80;}';
    eval 'sub MSTATUS {0x00;}';
    eval 'sub NOINTERRUPT {0x01;}';
    eval 'sub TxRDY {0x02;}';
    eval 'sub RxRDY {0x04;}';
    eval 'sub FFTMOUT {0x0c;}';
    eval 'sub RSTATUS {0x06;}';
    eval 'sub RIEN {0x01;}';
    eval 'sub TIEN {0x02;}';
    eval 'sub SIEN {0x04;}';
    eval 'sub MIEN {0x08;}';
    eval 'sub DTR {0x01;}';
    eval 'sub RTS {0x02;}';
    eval 'sub OUT1 {0x04;}';
    eval 'sub OUT2 {0x08;}';
    eval 'sub ASY_LOOP {0x10;}';
    eval 'sub DCTS {0x01;}';
    eval 'sub DDSR {0x02;}';
    eval 'sub DRI {0x04;}';
    eval 'sub DDCD {0x08;}';
    eval 'sub CTS {0x10;}';
    eval 'sub DSR {0x20;}';
    eval 'sub RI {0x40;}';
    eval 'sub DCD {0x80;}';
    eval 'sub DELTAS {
        local($x) = @_;
        eval "(($x)&( &DCTS| &DDSR| &DRI| &DDCD))";
    }';
    eval 'sub STATES {
        local($x) = @_;
        eval "(($x)( &CTS| &DSR| &RI| &DCD))";
    }';
    eval 'sub FIFO_OFF {0x00;}';
    eval 'sub FIFO_ON {0x01;}';
    eval 'sub FIFOEN {0x8f;}';
    eval 'sub FIFORCLR {0x8b;}';
    eval 'sub FIFORXFLSH {0x02;}';
    eval 'sub FIFOTXFLSH {0x04;}';
    eval 'sub FIFODMA {0x08;}';
    eval 'sub FIFO_TRIG_1 {0x00;}';
    eval 'sub FIFO_TRIG_4 {0x40;}';
    eval 'sub FIFO_TRIG_8 {0x80;}';
    eval 'sub FIFO_TRIG_14 {0xC0;}';
    eval 'sub AIOC {(ord(\'A\')<<8);}';
    eval 'sub AIOCINTTYPE {( &AIOC|60);}';
    eval 'sub AIOCDOSMODE {( &AIOC|61);}';
    eval 'sub AIOCNONDOSMODE {( &AIOC|62);}';
    eval 'sub AIOCSERIALOUT {( &AIOC|63);}';
    eval 'sub AIOCSERIALIN {( &AIOC|64);}';
    eval 'sub AIOCSETSS {( &AIOC|65);}';
    eval 'sub AIOCINFO {( &AIOC|66);}';
    eval 'sub VPC_SERIAL_DOS { &AIOCDOSMODE;}';
    eval 'sub VPC_SERIAL_NONDOS { &AIOCNONDOSMODE;}';
    eval 'sub VPC_SERIAL_INFO { &AIOCINFO;}';
    eval 'sub VPC_SERIAL_OUT { &AIOCSERIALOUT;}';
    eval 'sub VPC_SERIAL_IN { &AIOCSERIALIN;}';
    eval 'sub SO_DIVLLSB {1;}';
    eval 'sub SO_DIVLMSB {2;}';
    eval 'sub SO_LCR {3;}';
    eval 'sub SO_MCR {4;}';
    eval 'sub SI_MSR {1;}';
    eval 'sub SIO_MASK {
        local($elem) = @_;
        eval "(1<<(($elem)-1))";
    }';
    eval 'sub OVERRUN {040000;}';
    eval 'sub FRERROR {020000;}';
    eval 'sub PERROR {010000;}';
    eval 'sub S_ERRORS {( &PERROR| &OVERRUN| &FRERROR);}';
    eval 'sub RINGBITS {10;}';
    eval 'sub RINGSIZE {(1<< &RINGBITS);}';
    eval 'sub RINGMASK {( &RINGSIZE-1);}';
    eval 'sub RINGFRAC {8;}';
    eval 'sub RING_INIT {
        local($ap) = @_;
        eval "(($ap)-> &async_rput = ($ap)-> &async_rget = 0)";
    }';
    eval 'sub RING_CNT {
        local($ap) = @_;
        eval "((($ap)-> &async_rput - ($ap)-> &async_rget) &  &RINGMASK)";
    }';
    eval 'sub RING_FRAC {
        local($ap) = @_;
        eval "( &RING_CNT($ap) >= ( &RINGSIZE/ &RINGFRAC))";
    }';
    eval 'sub RING_POK {
        local($ap, $n) = @_;
        eval "( &RING_CNT($ap) < ( &RINGSIZE-($n)))";
    }';
    eval 'sub RING_PUT {
        local($ap, $c) = @_;
        eval "(($ap)-> &async_ring[($ap)-> &async_rput++ &  &RINGMASK] = ($c))";
    }';
    eval 'sub RING_UNPUT {
        local($ap) = @_;
        eval "(($ap)-> &async_rput--)";
    }';
    eval 'sub RING_GOK {
        local($ap, $n) = @_;
        eval "( &RING_CNT($ap) >= ($n))";
    }';
    eval 'sub RING_GET {
        local($ap) = @_;
        eval "(($ap)-> &async_ring[($ap)-> &async_rget++ &  &RINGMASK])";
    }';
    eval 'sub RING_EAT {
        local($ap, $n) = @_;
        eval "(($ap)-> &async_rget += ($n))";
    }';
    eval 'sub RING_MARK {
        local($ap, $c, $s) = @_;
        eval "(($ap)-> &async_ring[($ap)-> &async_rput++ &  &RINGMASK] = (($c)|($s)))";
    }';
    eval 'sub RING_UNMARK {
        local($ap) = @_;
        eval "(($ap)-> &async_ring[(($ap)-> &async_rget) &  &RINGMASK] &= ~ &S_ERRORS)";
    }';
    eval 'sub RING_ERR {
        local($ap, $c) = @_;
        eval "(($ap)-> &async_ring[(($ap)-> &async_rget) &  &RINGMASK] & ($c))";
    }';
    eval 'sub async_overrun { &async_uover. &_a. &uover_overrun;}';
    eval 'sub async_hw_overrun { &async_uover. &_a. &_hw;}';
    eval 'sub async_sw_overrun { &async_uover. &_a. &_sw;}';
    if (defined &_VPIX) {
    }
    if (defined &MERGE386) {
    }
    eval 'sub ASYNC_EXCL_OPEN {0x10000000;}';
    eval 'sub ASYNC_WOPEN {0x00000001;}';
    eval 'sub ASYNC_ISOPEN {0x00000002;}';
    eval 'sub ASYNC_OUT {0x00000004;}';
    eval 'sub ASYNC_CARR_ON {0x00000008;}';
    eval 'sub ASYNC_STOPPED {0x00000010;}';
    eval 'sub ASYNC_DELAY {0x00000020;}';
    eval 'sub ASYNC_BREAK {0x00000040;}';
    eval 'sub ASYNC_BUSY {0x00000080;}';
    eval 'sub ASYNC_DRAINING {0x00000100;}';
    eval 'sub ASYNC_SERVICEIMM {0x00000200;}';
    eval 'sub ASYNC_HW_IN_FLOW {0x00000400;}';
    eval 'sub ASYNC_HW_OUT_FLW {0x00000800;}';
    eval 'sub ASY82510 {0x1;}';
    eval 'sub ASY16550AF {0x2;}';
    eval 'sub ASY8250 {0x3;}';
    eval 'sub ASY_NEEDSOFT {0x00000001;}';
    eval 'sub ASY_DOINGSOFT {0x00000002;}';
    eval 'sub OUTLINE {(1 << ( &NBITSMINOR - 1));}';
    eval 'sub UNIT {
        local($x) = @_;
        eval "( &getminor($x) & ~ &OUTLINE)";
    }';
    eval 'sub ASYSETSOFT {
        local($asy) = @_;
        eval "{  &mutex_enter(& &asy_soft_lock); $asy-> &asy_flags |=  &ASY_NEEDSOFT;  &if (! &asysoftpend) {  &asysoftpend = 1;  &mutex_exit(& &asy_soft_lock);  &ddi_trigger_softintr( &asy_softintr_id); }  &else  &mutex_exit(& &asy_soft_lock);}";
    }';
    eval 'sub GETDATA {1;}';
    eval 'sub SENDDATA {0;}';
    if (defined &__cplusplus) {
    }
}
1;
