if (!defined &_SYS_KMEM_IMPL_H) {
    eval 'sub _SYS_KMEM_IMPL_H {1;}';
    require 'sys/kmem.ph';
    require 'sys/thread.ph';
    require 'sys/t_lock.ph';
    require 'sys/time.ph';
    require 'sys/kstat.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub KMF_AUDIT {0x00000001;}';
    eval 'sub KMF_DEADBEEF {0x00000002;}';
    eval 'sub KMF_REDZONE {0x00000004;}';
    eval 'sub KMF_VERIFY {0x00000008;}';
    eval 'sub KMF_NOMAGAZINE {0x00000010;}';
    eval 'sub KMF_PAGEPERBUF {0x00000020;}';
    eval 'sub KMF_NOCOLOR {0x00000040;}';
    eval 'sub KMF_READY {0x00000100;}';
    eval 'sub KMF_HASH {0x00000200;}';
    eval 'sub KMF_BUFTAG {( &KMF_AUDIT |  &KMF_DEADBEEF |  &KMF_REDZONE |  &KMF_VERIFY);}';
    eval 'sub KMEM_STACK_DEPTH {15;}';
    eval 'sub KMEM_LOG_SIZE {0x1000;}';
    eval 'sub KMEM_REDZONE_WORD {0xfeedface;}';
    eval 'sub KMEM_REDZONE_SIZE {2;}';
    eval 'sub KMEM_BUFTAG {
        local($cp, $buf) = @_;
        eval "( &kmem_buftag_t *)(($buf) + ($cp)-> &cache_offset)";
    }';
    eval 'sub KMEM_BUFTAG_ALLOC {0xa110c8ed;}';
    eval 'sub KMEM_BUFTAG_FREE {0xf4eef4ee;}';
    eval 'sub KMEM_MIN_HASH_SIZE {64;}';
    eval 'sub KMEM_HASH {
        local($cp, $buf) = @_;
        eval "(($cp)-> &cache_hash_table + ((($buf) >> ($cp)-> &cache_hash_shift) & ($cp)-> &cache_hash_mask))";
    }';
    eval 'sub KMEM_DEPOT_CONTENTION {15;}';
    eval 'sub KMEM_CPU_CACHE_SIZE {64;}';
    eval 'sub KMEM_CPU_PAD {( &KMEM_CPU_CACHE_SIZE - $sizeof{ &kmutex_t} - 4 * $sizeof{\'int\'} - 3 * $sizeof{ &void *});}';
    eval 'sub KMEM_CACHE_SIZE {
        local($ncpus) = @_;
        eval "((&(( &kmem_cache_t *)0)-> &cache_cpu[$ncpus]))";
    }';
    eval 'sub KMEM_CACHE_NAMELEN {31;}';
    eval 'sub KMEM_PERM_MINFREE {32;}';
    eval 'sub KMEM_ALIGN {8;}';
    eval 'sub KMEM_ALIGN_SHIFT {3;}';
    eval 'sub KMEM_VOID_FRACTION {8;}';
    if (defined &__cplusplus) {
    }
}
1;
