if (!defined &_SYS_MMU_H) {
    eval 'sub _SYS_MMU_H {1;}';
    require 'sys/pte.ph';
    if (defined &__cplusplus) {
    }
    if (!defined &_ASM) {
	eval 'sub good_addr {
	    local($a) = @_;
	    eval "(1)";
	}';
    }
    eval 'sub MMU_PFEC_P {0x1;}';
    eval 'sub MMU_PFEC_WRITE {0x2;}';
    eval 'sub MMU_PFEC_USER {0x4;}';
    eval 'sub MMU_PFEC_AT_MASK {( &MMU_PFEC_USER| &MMU_PFEC_WRITE);}';
    eval 'sub MMU_PFEC_AT_UREAD { &MMU_PFEC_USER;}';
    eval 'sub MMU_PFEC_AT_UWRITE {( &MMU_PFEC_USER| &MMU_PFEC_WRITE);}';
    eval 'sub MMU_PFEC_AT_SREAD {0;}';
    eval 'sub MMU_PFEC_AT_SWRITE { &MMU_PFEC_WRITE;}';
    if (defined( &_KERNEL) && !defined( &_ASM)) {
	eval 'sub vac_init {
	    eval "";
	}';
	eval 'sub vac_usrflush {
	    eval "";
	}';
	eval 'sub vac_ctxflush {
	    eval "";
	}';
	eval 'sub vac_segflush {
	    local($base) = @_;
	    eval "";
	}';
	eval 'sub vac_pageflush {
	    local($base) = @_;
	    eval "";
	}';
	eval 'sub vac_flush {
	    local($base, $len) = @_;
	    eval "";
	}';
    }
    if (!defined &MMU_PAGESIZE) {
	eval 'sub MMU_PAGESIZE {4096;}';
    }
    eval 'sub NPTEPERPT {1024;}';
    eval 'sub NPTESHIFT {10;}';
    eval 'sub PTSIZE {( &NPTEPERPT *  &MMU_PAGESIZE);}';
    eval 'sub PTOFFSET {( &PTSIZE - 1);}';
    eval 'sub FOURMB_PAGESIZE {0x400000;}';
    eval 'sub FOURMB_PAGEOFFSET {( &FOURMB_PAGESIZE - 1);}';
    eval 'sub FOURMB_PAGESHIFT {22;}';
    if (!defined &_ASM) {
	eval 'sub mmu_tlbflush_all {
	    eval " &setcr3( &cr3())";
	}';
	eval 'sub mmu_pdeptr_cpu {
	    local($cpu, $addr) = @_;
	    eval "&(($cpu)-> &cpu_pagedir[($addr) >> 22])";
	}';
	eval 'sub mmu_pdeload_cpu {
	    local($cpu, $addr, $value) = @_;
	    eval "(*( &mmu_pdeptr_cpu($cpu, $addr)) = ($value))";
	}';
	eval 'sub mmu_pdeptr {
	    local($addr) = @_;
	    eval " &mmu_pdeptr_cpu( &CPU, $addr)";
	}';
	eval 'sub mmu_pdeload {
	    local($addr, $value) = @_;
	    eval " &mmu_pdeload_cpu( &CPU, $addr, $value)";
	}';
	eval 'sub mmu_loadcr3 {
	    local($cpu) = @_;
	    eval "((($cpu)-> &cpu_current_as ==  &NULL) ?  &setcr3( &kernel_only_cr3) :  &setcr3( &cr3()))";
	}';
    }
    if (defined &__cplusplus) {
    }
}
1;
