if (!defined &_SYS_X86_ARCHEXT_H) {
    eval 'sub _SYS_X86_ARCHEXT_H {1;}';
    if (defined &__cplusplus) {
    }
    eval 'sub P5_PSE_SUPPORTED {0x08;}';
    eval 'sub P5_TSC_SUPPORTED {0x10;}';
    eval 'sub P5_MSR_SUPPORTED {0x20;}';
    eval 'sub P6_APIC_SUPPORTED {0x200;}';
    eval 'sub P6_MTRR_SUPPORTED {0x1000;}';
    eval 'sub P6_PGE_SUPPORTED {0x2000;}';
    eval 'sub K5_PGE_SUPPORTED {0x20;}';
    eval 'sub K5_SCE_SUPPORTED {0x40;}';
    eval 'sub K5_PSE {0x10;}';
    eval 'sub K5_GPE {0x20;}';
    eval 'sub K5_PGE {0x200;}';
    eval 'sub P5_PSE {0x10;}';
    eval 'sub P6_GPE {0x80;}';
    eval 'sub P6_PGE {0x2000;}';
    eval 'sub P5_MCHADDR {0x0;}';
    eval 'sub P5_CTR1 {0x13;}';
    eval 'sub K5_MCHADDR {0x0;}';
    eval 'sub K5_MCHTYPE {0x01;}';
    eval 'sub K5_TSC {0x10;}';
    eval 'sub K5_TR12 {0x12;}';
    eval 'sub REG_MTRRCAP {0xfe;}';
    eval 'sub REG_MTRRDEF {0x2ff;}';
    eval 'sub REG_MTRR64K {0x250;}';
    eval 'sub REG_MTRR16K1 {0x258;}';
    eval 'sub REG_MTRR16K2 {0x259;}';
    eval 'sub REG_MTRR4K1 {0x268;}';
    eval 'sub REG_MTRR4K2 {0x269;}';
    eval 'sub REG_MTRR4K3 {0x26a;}';
    eval 'sub REG_MTRR4K4 {0x26b;}';
    eval 'sub REG_MTRR4K5 {0x26c;}';
    eval 'sub REG_MTRR4K6 {0x26d;}';
    eval 'sub REG_MTRR4K7 {0x26e;}';
    eval 'sub REG_MTRR4K8 {0x26f;}';
    eval 'sub REG_MTRRPHYSBASE0 {0x200;}';
    eval 'sub REG_MTRRPHYSMASK7 {0x20f;}';
    eval 'sub REG_MC0_CTL {0x400;}';
    eval 'sub REG_MC5_MISC {0x417;}';
    eval 'sub REG_PERFCTR0 {0xc1;}';
    eval 'sub REG_PERFCTR1 {0xc2;}';
    eval 'sub REG_PERFEVNT0 {0x186;}';
    eval 'sub REG_PERFEVNT1 {0x187;}';
    eval 'sub REG_TSC {0x10;}';
    eval 'sub REG_APIC_BASE_MSR {0x1b;}';
    eval 'sub MTRRTYPE_MASK {0xff;}';
    eval 'sub MTRRCAP_FIX {0x100;}';
    eval 'sub MTRRCAP_VCNTMASK {0xff;}';
    eval 'sub MTRRCAP_USWC {0x400;}';
    eval 'sub MTRRDEF_E {0x800;}';
    eval 'sub MTRRDEF_FE {0x400;}';
    eval 'sub MTRRPHYSMASK_V {0x800;}';
    eval 'sub MTRR_SETTYPE {
        local($a, $t) = @_;
        eval "(($a &= ~0xff), ($a |= (($t) & 0xff)))";
    }';
    eval 'sub MTRR_SETVINVALID {
        local($a) = @_;
        eval "($a &= ~ &MTRRPHYSMASK_V)";
    }';
    eval 'sub MTRR_SETVBASE {
        local($a, $b, $t) = @_;
        eval "($a[1] = 0, ($a[0] = (((($b)) & 0xfffff000) | (($t) & 0xff))))";
    }';
    eval 'sub MTRR_SETVMASK {
        local($a, $s, $v) = @_;
        eval "($a[1] = 0x0f, ($a[0] = (~($s - 1) & 0xfffff000) | ($v << 11)))";
    }';
    eval 'sub MTRR_GETVBASE {
        local($a) = @_;
        eval "($a & 0xfffff000)";
    }';
    eval 'sub MTRR_GETVTYPE {
        local($a) = @_;
        eval "($a & 0xff)";
    }';
    eval 'sub MTRR_GETVSIZE {
        local($a) = @_;
        eval "(~$a & 0xfffff000)";
    }';
    eval 'sub MAX_MTRRVAR {8;}';
    eval 'sub mtrrphys_base { &mtrrphysbase[0];}';
    eval 'sub mtrrphys_mask { &mtrrphysmask[0];}';
    eval 'sub X86_LARGEPAGE {0x01;}';
    eval 'sub X86_TSC {0x02;}';
    eval 'sub X86_MSR {0x04;}';
    eval 'sub X86_MTRR {0x08;}';
    eval 'sub X86_PGE {0x10;}';
    eval 'sub X86_APIC {0x20;}';
    eval 'sub X86_P5 {0x10000;}';
    eval 'sub X86_K5 {0x20000;}';
    eval 'sub X86_P6 {0x40000;}';
    eval 'sub X86_CPU_TYPE {0xff0000;}';
    eval 'sub CR0_CD {0x40000000;}';
    eval 'sub CR0_NW {0x20000000;}';
    eval 'sub INST_RDMSR {0x320f;}';
    eval 'sub INST_WRMSR {0x300f;}';
    eval 'sub INST_RTSC {0x310f;}';
    eval 'sub RDWRMSR_INST_LEN {2;}';
    if (defined &__cplusplus) {
    }
}
1;
