if (!defined &_TZFILE_H) {
    eval 'sub _TZFILE_H {1;}';
    if (defined &__cplusplus) {
    }
    if (!defined &TZDIR) {
	eval 'sub TZDIR {"/usr/share/lib/zoneinfo";}';
    }
    if (!defined &TZDEFAULT) {
	eval 'sub TZDEFAULT {"localtime";}';
    }
    if (!defined &TZDEFRULES) {
	eval 'sub TZDEFRULES {"posixrules";}';
    }
    if (!defined &TZ_MAX_TIMES) {
	eval 'sub TZ_MAX_TIMES {370;}';
    }
    if (!defined &TZ_MAX_TYPES) {
	if (!defined &NOSOLAR) {
	    eval 'sub TZ_MAX_TYPES {256;}';
	}
	if (defined &NOSOLAR) {
	    eval 'sub TZ_MAX_TYPES {20;}';
	}
    }
    if (!defined &TZ_MAX_CHARS) {
	eval 'sub TZ_MAX_CHARS {50;}';
    }
    if (!defined &TZ_MAX_LEAPS) {
	eval 'sub TZ_MAX_LEAPS {50;}';
    }
    eval 'sub SECSPERMIN {60;}';
    eval 'sub MINSPERHOUR {60;}';
    eval 'sub HOURSPERDAY {24;}';
    eval 'sub DAYSPERWEEK {7;}';
    eval 'sub DAYSPERNYEAR {365;}';
    eval 'sub DAYSPERLYEAR {366;}';
    eval 'sub SECSPERHOUR {( &SECSPERMIN *  &MINSPERHOUR);}';
    eval 'sub SECSPERDAY {(  &SECSPERHOUR *  &HOURSPERDAY);}';
    eval 'sub MONSPERYEAR {12;}';
    eval 'sub TM_SUNDAY {0;}';
    eval 'sub TM_MONDAY {1;}';
    eval 'sub TM_TUESDAY {2;}';
    eval 'sub TM_WEDNESDAY {3;}';
    eval 'sub TM_THURSDAY {4;}';
    eval 'sub TM_FRIDAY {5;}';
    eval 'sub TM_SATURDAY {6;}';
    eval 'sub TM_JANUARY {0;}';
    eval 'sub TM_FEBRUARY {1;}';
    eval 'sub TM_MARCH {2;}';
    eval 'sub TM_APRIL {3;}';
    eval 'sub TM_MAY {4;}';
    eval 'sub TM_JUNE {5;}';
    eval 'sub TM_JULY {6;}';
    eval 'sub TM_AUGUST {7;}';
    eval 'sub TM_SEPTEMBER {8;}';
    eval 'sub TM_OCTOBER {9;}';
    eval 'sub TM_NOVEMBER {10;}';
    eval 'sub TM_DECEMBER {11;}';
    eval 'sub TM_SUNDAY {0;}';
    eval 'sub TM_YEAR_BASE {1900;}';
    eval 'sub EPOCH_YEAR {1970;}';
    eval 'sub EPOCH_WDAY { &TM_THURSDAY;}';
    eval 'sub isleap {
        local($y) = @_;
        eval "(((($y) % 4) == 0 && (($y) % 100) != 0) || (($y) % 400) == 0)";
    }';
    eval 'sub SECS_PER_MIN { &SECSPERMIN;}';
    eval 'sub MINS_PER_HOUR { &MINSPERHOUR;}';
    eval 'sub HOURS_PER_DAY { &HOURSPERDAY;}';
    eval 'sub DAYS_PER_WEEK { &DAYSPERWEEK;}';
    eval 'sub DAYS_PER_NYEAR { &DAYSPERNYEAR;}';
    eval 'sub DAYS_PER_LYEAR { &DAYSPERLYEAR;}';
    eval 'sub SECS_PER_HOUR { &SECSPERHOUR;}';
    eval 'sub SECS_PER_DAY { &SECSPERDAY;}';
    eval 'sub MONS_PER_YEAR { &MONSPERYEAR;}';
    if (defined &__cplusplus) {
    }
}
1;
